package org.spring.jmsinterop.bo;

import java.util.List;

public class TradeRequest {
	
	private String ticker;
	
	private long quantity;
	
	private double price;
	
	private String orderType;
	
	private String accountName;
	
	private boolean buyRequest;
	
	private String userName;
	
	private String requestId;

	public String getAccountName() {
		return accountName;
	}

	public void setAccountName(String accountName) {
		this.accountName = accountName;
	}

	public boolean isBuyRequest() {
		return buyRequest;
	}

	public void setBuyRequest(boolean buyRequest) {
		this.buyRequest = buyRequest;
	}

	public String getOrderType() {
		return orderType;
	}

	public void setOrderType(String orderType) {
		this.orderType = orderType;
	}

	public double getPrice() {
		return price;
	}

	public void setPrice(double price) {
		this.price = price;
	}

	public long getQuantity() {
		return quantity;
	}

	public void setQuantity(long quantity) {
		this.quantity = quantity;
	}

	public String getRequestId() {
		return requestId;
	}

	public void setRequestId(String requestId) {
		this.requestId = requestId;
	}

	public String getTicker() {
		return ticker;
	}

	public void setTicker(String ticker) {
		this.ticker = ticker;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}
	
	public boolean validate(List validationErrors)
	{
		  if (userName == null)
          {
              validationErrors.add("User name not specified");
          }
          if (requestId == null || requestId.length() == 0)
          {
              validationErrors.add("Request Id not specified");
          }
          if (!orderType.equals("MARKET"))
          {
              if (price <= 0)
              {
                  validationErrors.add("Market order must have a price");
              }
          }
		
		return validationErrors.size() > 0;
	}


	
	
	
	

}
