package org.spring.jmsinterop.gateways;

import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.jms.core.support.JmsGatewaySupport;

public class MarketDataGateway extends JmsGatewaySupport implements Runnable {

	private Random random;
	private int sleepTimeInSeconds;
	
	protected final Log logger = LogFactory.getLog(getClass());
	
	public MarketDataGateway()
	{
		random = new Random();
	}
	
	


	public void setSleepTimeInSeconds(int sleepTimeInSeconds) {
		this.sleepTimeInSeconds = sleepTimeInSeconds;
	}



	public void run() {
		
		
		while (true) {
			Map data = generateFakeMarketData();
			logger.info("Sending market data.");
			getJmsTemplate().convertAndSend(data);
			
			try {
				Thread.sleep(sleepTimeInSeconds*1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
		}		
	}

	private Map generateFakeMarketData() {
		Map md = new HashMap();
		
		md.put("TICKER", "CSCO");
		md.put("PRICE", "28." + Math.abs(generateRandomLong(10)));
		return md;
	}
	
	private long generateRandomLong(int width) {
		return new Double(random.nextGaussian() * width).longValue();
	}

	
	
}
