package org.spring.jmsinterop.util;

import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.Session;

import org.springframework.jms.support.JmsUtils;

public class Messages {

	public static void setMessageObject(MapMessage mm, String fieldName, Object fieldVal) {
		
		try {
			mm.setObject(fieldName, fieldVal);
		} catch (JMSException e) {
			throw JmsUtils.convertJmsAccessException(e);
		}
	}
	
	public static MapMessage createMapMessage(Session session)
	{
		try {
			return session.createMapMessage();
		} catch (JMSException e) {			
			throw JmsUtils.convertJmsAccessException(e);
		}
	}
	
	public static void setBooleanProperty(Message message, String fieldName, boolean val)
	{
		try {
			message.setBooleanProperty(fieldName, val);
		} catch (JMSException e) {			
			throw JmsUtils.convertJmsAccessException(e);
		}
	}
}
