using System;
using System.Collections;
using System.Reflection;
using Spring.JmsInterop.Converters;
using TIBCO.EMS;

namespace Spring.JmsInterop.Builders
{
    public class PrimitiveArrayBuilder : IBuilder
    {
        private Hashtable primitiveArrayTypes = new Hashtable();
        
        public PrimitiveArrayBuilder()
        {
            InitDictionary();
            
        }

        private void InitDictionary()
        {
            primitiveArrayTypes.Add("System.Int16[]", "");
            primitiveArrayTypes.Add("System.Int32[]", "");
            primitiveArrayTypes.Add("System.Int64[]", "");
            primitiveArrayTypes.Add("System.Single[]", "");
            primitiveArrayTypes.Add("System.Double[]", "");
            primitiveArrayTypes.Add("System.UInt16[]", "");
            primitiveArrayTypes.Add("System.UInt32[]", "");
            primitiveArrayTypes.Add("System.UInt64[]", "");
            primitiveArrayTypes.Add("System.Byte[]", "");
            
            //TODO these need special handling.
            //primitiveArrayTypes.Add("System.Boolean[]", "");
            //primitiveArrayTypes.Add("System.Char[]", "");
        }

        public bool CanBuild(Type targetType)
        {
            return primitiveArrayTypes.ContainsKey(targetType.FullName);
        }

        public void AddValue(MapMessage mm, Session session, ConversionContext conversionContext, string fieldName, Type fieldType, object fieldVal)
        {
            mm.SetBooleanProperty("JMS_TIBCO_MSG_EXT", true);
            mm.SetObject(fieldName, fieldVal);
        }

        public void SetValue(MapMessage mapMessage, ConversionContext conversionContext, object targetObject, object fieldVal, FieldInfo targetFieldInfo)
        {
            targetFieldInfo.SetValue(targetObject, fieldVal);
        }
    }
}
