using System;
using System.Collections;
using System.Reflection;
using Spring.JmsInterop.Converters;
using TIBCO.EMS;

namespace Spring.JmsInterop.Builders
{
    public class PrimitiveTypeBuilder : IBuilder
    {
        private Hashtable primitiveTypes = new Hashtable();
        
        public PrimitiveTypeBuilder()
        {
            InitDictionary();
        }

        private void InitDictionary()
        {
            
            //TODO use .IsPrimitive instead?
            primitiveTypes.Add("System.Int16", "");
            primitiveTypes.Add("System.Int32", "");
            primitiveTypes.Add("System.Int64", "");
            primitiveTypes.Add("System.Single", "");
            primitiveTypes.Add("System.Double", "");
            primitiveTypes.Add("System.UInt16", "");
            primitiveTypes.Add("System.UInt32", "");
            primitiveTypes.Add("System.UInt64", "");
            primitiveTypes.Add("System.Byte", "");
            primitiveTypes.Add("System.Boolean", "");
            primitiveTypes.Add("System.Char", "");
        }

        public bool CanBuild(Type targetType)
        {
            return primitiveTypes.ContainsKey(targetType.FullName);
        }

        public void AddValue(MapMessage mm, Session session, ConversionContext conversionContext, string fieldName, Type fieldType, object fieldVal)
        {
            mm.SetObject(fieldName, fieldVal);
        }

        public void SetValue(MapMessage mapMessage, ConversionContext conversionContext, object targetObject, object fieldVal, FieldInfo targetFieldInfo)
        {
            targetFieldInfo.SetValue(targetObject, fieldVal);
        }

    }
}
