using System;
namespace Spring.JmsInterop.Bo
{
	
	public class TradeRequest
	{
		virtual public System.String AccountName
		{
			get
			{
				return accountName;
			}
			
			set
			{
				this.accountName = value;
			}
			
		}
		virtual public bool BuyRequest
		{
			get
			{
				return buyRequest;
			}
			
			set
			{
				this.buyRequest = value;
			}
			
		}
		virtual public System.String OrderType
		{
			get
			{
				return orderType;
			}
			
			set
			{
				this.orderType = value;
			}
			
		}
		virtual public double Price
		{
			get
			{
				return price;
			}
			
			set
			{
				this.price = value;
			}
			
		}
		virtual public long Quantity
		{
			get
			{
				return quantity;
			}
			
			set
			{
				this.quantity = value;
			}
			
		}
		virtual public System.String RequestId
		{
			get
			{
				return requestId;
			}
			
			set
			{
				this.requestId = value;
			}
			
		}
		virtual public System.String Ticker
		{
			get
			{
				return ticker;
			}
			
			set
			{
				this.ticker = value;
			}
			
		}
		virtual public System.String UserName
		{
			get
			{
				return userName;
			}
			
			set
			{
				this.userName = value;
			}
			
		}
		
		private System.String ticker;
		
		private long quantity;
		
		private double price;
		
		private System.String orderType;
		
		private System.String accountName;
		
		private bool buyRequest;
		
		private System.String userName;
		
		private System.String requestId;
		
		public virtual bool validate(System.Collections.IList validationErrors)
		{
			if (userName == null)
			{
				validationErrors.Add("User name not specified");
			}
			if (requestId == null || requestId.Length == 0)
			{
				validationErrors.Add("Request Id not specified");
			}
			if (!orderType.Equals("MARKET"))
			{
				if (price <= 0)
				{
					validationErrors.Add("Market order must have a price");
				}
			}
			
			return validationErrors.Count > 0;
		}
	}
}