

using System.Collections;
using Spring.JmsInterop.Bo;
using Spring.JmsInterop.Gateway;

namespace Spring.JmsInterop.UI
{
    public class StockController
    {
        private StockForm stockForm;
              
        private IStockServiceGateway stockServiceGateway;


        
        public StockForm StockForm
        {
            get { return stockForm; }
            set { stockForm = value; }
        }

        public IStockServiceGateway StockServiceGateway
        {
            get { return stockServiceGateway; }
            set { stockServiceGateway = value; }
        }

        public void SendTradeRequest()
        {
            TradeRequest tradeRequest = new TradeRequest();
            tradeRequest.AccountName = "ACCT-123";
            tradeRequest.BuyRequest = true;
            tradeRequest.OrderType = "MARKET";
            tradeRequest.Quantity = 314000000;
            tradeRequest.RequestId = "REQ-1";
            tradeRequest.Ticker = "CSCO";
            tradeRequest.UserName = "Joe Trader";
            
            stockServiceGateway.Send(tradeRequest);
        }
        
        public void SendPortfolioRequest()
        {
            User user = new User();
            user.UserName = "Joe Trader";
            user.AccountName = "ACCT-123";
            PortfolioRequest portfolioRequest = new PortfolioRequest(user);
            stockServiceGateway.Send(portfolioRequest);
        }
        
        public void UpdateMarketData(IDictionary marketDataDict)
        {
            stockForm.UpdateMarketData(marketDataDict);
        }

        public void UpdateTrade(Trade trade)
        {
            stockForm.UpdateTrade(trade);
        }

        public void UpdatePortfolio(Portfolio portfolio)
        {
            stockForm.UpdatePortfolio(portfolio);
        }
    }
}
