using System.Collections;

namespace Spring.JmsInterop.Util
{
    public class ObjectIdentityLookup
    {
        private IDictionary dict = new Hashtable();
        
        public void Add(object obj)
        {
            dict.Add(new IdentityWrapper(obj), "");
        }
        
        public void Remove(object obj)
        {
            dict.Remove(new IdentityWrapper(obj));
        }
        
        public bool Contains(object obj)
        {
            return dict.Contains(new IdentityWrapper(obj));
        }
        
        public object Get(object obj)
        {
            return dict[new IdentityWrapper(obj)];
        }
    }

    internal class IdentityWrapper
    {
        private object obj;
        public IdentityWrapper(object obj)
        {
            this.obj = obj;
        }
        
        public override int GetHashCode()
        {
            return HashCodeProvider.GetIdentityHashCode(obj);
        }
        
        public override bool Equals(object otherObject)
        {
            return obj == ((IdentityWrapper)otherObject).obj;
        }
        
        public override string ToString()
        {
            return obj.ToString();
            
        }
    }
}
