using System;
using System.Collections;
using System.Reflection;

namespace Spring.JmsInterop.Util
{
    public class ReflectionUtils
    {
        private static readonly Hashtable fieldCache = new Hashtable();

        public static FieldInfo[] GetFields(Type type)
        {
            lock (fieldCache)
            {
                FieldInfo[] fields = (FieldInfo[]) fieldCache[type];
                if (fields == null)
                {
                    fields = type.GetFields(BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance |
                                            BindingFlags.Static);
                    fieldCache[type] = fields;
                }
                return fields;
            }
        }
    }
}