using System;
using System.Threading;
using System.Windows.Forms;
using log4net;
using Spring.Context;
using Spring.Context.Support;
using Spring.JmsInterop.UI;

namespace Spring.JmsInterop
{
    public class Program
    {

        #region Logging Definition

        private static readonly ILog log = LogManager.GetLogger(typeof(Program));

        #endregion
        
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        public static void Main()
        {
            try
            {
                //BasicConfigurator.Configure();
                log.Info("Running....");
                using (IApplicationContext ctx = ContextRegistry.GetContext())
                {
                    StockForm stockForm = new StockForm();
                    Application.ThreadException += ThreadException;
                    Application.Run(stockForm);
                }
            }
            catch (Exception e)
            {
                log.Error("JmsInterop Demo is broken.", e);
            }
            finally
            {
                //Console.WriteLine();
                //Console.WriteLine("--- hit <return> to quit ---");
                //Console.ReadLine();
            }
            
        }

        private static void ThreadException(object sender, ThreadExceptionEventArgs e)
        {
            log.Error("Uncaught application exception.", e.Exception);
            Application.Exit();
        }
    }
}